#open"compilateur_commun";;
#open"lexeur_scheme";;
#open"parseur_scheme";;
#open"traducteur_scheme";;
#open"sys";;

exception Erreur
;;

let compile_scheme fic =
  try
    let org_canal = open_in (fic ^ ".miniscm") in
    let perm = s_ixall + s_irall + s_iwall in
    let mode = [O_WRONLY; O_TRUNC; O_CREAT; O_BINARY] in
    let dest_canal = open_out_gen mode perm fic in
    let tampon = lexing__create_lexer_channel org_canal in
    let code = compile_commun (traduit_scheme (Programme Token tampon)) in
    output_string dest_canal "#!lanceur\n";
    output_value dest_canal code;
    close_in org_canal;
    close_out dest_canal
  with
    Sys_error s ->
       print_endline ("Erreur: "^s);
       print_newline();
       raise Erreur
  | parsing__Parse_error f ->
       print_string "Erreur de syntaxe";
       print_newline();
       raise Erreur
  | Failure s ->
       print_string ("Erreur : "^s);
       print_newline();
       raise Erreur
;;

if interactive
   then ()
   else
     if (vect_length command_line) <> 2
         then begin
           print_string "Mauvais nombre d'argument";
      	   print_newline();
           exit 1
         end
         else
	   try compile_scheme command_line.(1); exit 0
       	   with Erreur -> exit 1
;;
